# Android 插件框架 PhantomAPK 开源计划书

## 简介

PhantomAPK 是运力科技 Android 组研发的一套 完整、稳定、灵活，兼容性好的全面插件化方案。

『插件化』顾名思义，就是把一些业务模块封装成独立的插件，然后根据不同业务需求组合成不同的产品，支持按需加载，动态升级。

插件化带来了以下好处：

- 模块化、解耦合、并行开发
- 用户不用重新安装 APK 就能升级应用功能，降低宿主发版本频率
- 提供一种快速修复线上 BUG 的能力。
- 按需加载不同的模块，减小宿主 APK 包大小

Android 组借助 PhantomAPK 实现了全面插件化：

- 业务模块（钱包、ETC、加油等）不需要再等待司机版发布的班车（两周一迭代），可以随时以插件的方式进行发布，缩短了业务功能上线周期。
  - 例如：司机版平均发版周期从 10 个工作日缩短到 1.7 个工作日（备注：司机版以及集成的插件 2017 年总共发版 148 次，平均发版周期 1.7 工作日）
- 独立解耦，公共的插件（如：钱包）无需修改即可快速集成到新的宿主

PhantomAPK 的优势

- 完整：插件支持独立应用的绝大部分特性
- 稳定：历经货车帮旗下多款产品两年千万级用户验证
- 灵活：宿主无需升级（无需在宿主 AndroidManifest.xml 中预埋组件），即可支持插件新增组件，甚至新增插件
- 兼容性好：没有调用系统的『隐藏 API』，完美兼容 Android 9.0
- 易于集成：无论插件端还是宿主端，只需 **数行** 就能完成接入，改造成本低

## 为什么开源

1. 树立品牌形象
2. 扩大影响范围
3. 实现额外功能
4. 吸引和留住人才
5. 提升代码质量

## 如何开源

### 开源渠道

Github

建议账号由公司企业效能组统一管理

### 开源协议

由于项目中使用了部分 Apache/MIT 协议的开源项目代码，建议使用 MIT 协议

### 后续维护

Android 组计划投入一位同学全职在该项目，负责:

- 新功能开发和 Bug fix
- 完善文档
- 处理用户反馈
  - Github issue
  - Merge Request
  - 邮件
  - 技术支持 QQ 群/微信群

### 推广渠道

- 线上媒体：InfoQ, 公众号，掘金，Weibo 等
- 线下活动，技术交流

## 法务/安全方面的问题

告知公司的法律团队/IT安全团队，检查以下事项；

- 第三方资源
- 商业机密
- 专利
- 商标
- 隐私

## 实施时间表

| 工作项 | 计划完成时间 | 负责人 | 备注 |
| ---- | ---- | ---- | ---- |
| 整理源代码 | 2018-08-31 | 邵彬 | 剥离与公司项目耦合的逻辑 <br/> 整理代码，做到风格一致 <br/> 完善注释 <br/>
| 撰写文档  | 2018-09-10 | 刘松 | 项目发布新闻稿 <br/> README <br/> 贡献指南说明 <br/> 行为规范指导 <br/> 技术文档
| 编写示例应用 | 2018-08-31 | 刘松 | 除了 README 中 hello world 快速上手外，还需要有各种场景下的示例
| 组织 review | 2018-09-14 | 刘松 | 文档<br/>代码<br/>法务<br/>安全 |
| 上传代码/文档到 Github | TBD | 刘松 |  |

## 开源插件框架项目影响力数据对比

| 项目 | star | fork | 主体 |
| ---- | ---- | ---- | ---- |
| Atlas | 6290 | 1202 | 公司（阿里） |
| DroidPlugin | 5811 | 2399 | 公司（360）|
| Replugin | 4867 | 948 | 公司（360） |
| VirtualAPK | 6130 | 953 | 公司（滴滴） |
| ZeusPlugin | 771 | 151 | 公司（掌阅）
| TwsPluginFramework | 59 | 20 | 公司(腾讯 paceware)
| dynamic-load-apk | 5425 | 1986 | 个人（singwhatiwanna）
| Small | 4317 | 1055 | 个人(wequick) |
| Android-Plugin-Framework | 1285 | 405 | 个人(limpoxe)